package org.playframework.playtools.popup.actions;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IncrementalProjectBuilder;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.playframework.playtools.util.PlayToolsUtil;
import org.playframework.playtools.util.config.IPlayConfigManager;
import org.playframework.playtools.util.config.PlayConfigManager;
import org.playframework.playtools.util.invoker.PlayInvoker;
import org.playframework.playtools.util.invoker.PlayInvokerVersion1;
import org.playframework.playtools.util.invoker.PlayInvokerVersion2;

public class Eclipsify2 implements IObjectActionDelegate {

	private Shell shell;

	/**
	 * Constructor for Action1.
	 */
	public Eclipsify2() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		shell = targetPart.getSite().getShell();
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		String projectPath = PlayToolsUtil.getSelectProjectPath();
		if ("".equals(projectPath)) {
			return;
		}
		String frameworkPath = "";
		String version = PlayToolsUtil.getPlayVersion(projectPath);

		Shell shell = new Shell();
		EclipsifyDialog d = new EclipsifyDialog(shell);
		d.setPlayVersion(version);
		int ret = d.open();
		if (ret != IDialogConstants.OK_ID) {
			return;
		}
		version = d.getPlayVersion();
		frameworkPath = PlayToolsUtil.getPlayRootPath(version);

		IProject projectHandle = PlayToolsUtil.getSelectProject();

		IPlayConfigManager manager = PlayConfigManager.PlayConfigManagerFactory(version, 0);

		manager.createVersionFile(projectHandle);

		PlayInvoker.reEclipsify(frameworkPath, version, projectPath);

	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

}
