package org.playframework.playtools.util.invoker;

import org.playframework.playtools.util.PlayToolsUtil;
import org.playframework.playtools.util.console.PlayMessageConsole;

public class PlayInvokerVersion2 extends AbstractPlayInvoker {

	public PlayInvokerVersion2() {
	}

	public PlayInvokerVersion2(String payRootPath, String version, String projectPath, String port) {
		super(payRootPath, version, projectPath, port);
	}

	protected void launchPlay() {

		createLancher("");

		lancher.execPlay(payRootPath, version, projectPath, port);

	}

	public void eclipsify(String frameworkPath, String version, String projectPath) {

		createLancher("eclipsify");

		lancher.execBuld(frameworkPath, version, projectPath, false);

	}

	public void reEclipsify(String frameworkPath, String version, String projectPath) {
		
		PlayToolsUtil.replaceBuildSbt(projectPath, version);
		
		createLancher("eclipsify");

		lancher.execReBuld(frameworkPath, version, projectPath, false);

	}

	private void createLancher(String command) {
		messageConsole = new PlayMessageConsole(consoleTitle);
		lancher = new Play2Launcher(messageConsole);
		messageConsole.println(consoleTitle + " version " + version + " " + command + " start...");
	}

}
